
/* Programma che simula il gioco del poker e calcola la probabilita' di avere un colore servito */

#include<stdio.h>
#include<stdlib.h>
#include<time.h>

#define NMANI 10000000
#define NGIOCATORI 4

typedef enum {fiori, quadri, cuori, picche} TSeme;

struct TCarta {
  int valore;
  TSeme seme;
};

typedef struct TCarta TCarta;

void assegna(TCarta *c, int v, TSeme s) {
  c->valore = v;
  c->seme = s;
}

void stampa_carta(TCarta c) {
  int valore = c.valore;
  TSeme seme = c.seme;

  char *nome_seme;
  switch (seme) {
  case cuori : nome_seme = "cuori"; break;
  case fiori : nome_seme = "fiori"; break;
  case quadri : nome_seme = "quadri"; break;
  case picche : nome_seme = "picche"; break;
  }
  
  printf("carta: %d di %s\n", valore, nome_seme);
}

void scambia(TCarta *c1, TCarta *c2) {

  TCarta c3 = *c1;
  *c1 = *c2;
  *c2 = c3;

}

void mescola(TCarta mazzo[52]) {
  int i, r;

  for (i=0; i<52; i++) {
    r = rand()%52;
    scambia(&mazzo[i],&mazzo[r]);
  }
}

void dai_le_carte(TCarta mazzo[52], TCarta mano[NGIOCATORI][5]) {
  int conta_carte = 0;

  int i,j;
  for (i=0; i<5; i++)
    for (j=0; j<NGIOCATORI; j++) {
      mano[j][i] = mazzo[conta_carte++];
    }
}

int colore(TCarta mano[5]){
  int i;
  for (i=1; i<5; i++)
    if (mano[i].seme != mano[0].seme)
      return 0;
  return 1;
}

void gioca_poker(TCarta mazzo[52]) {
  
  int conta_colore=0;
  int conta_mani = 0;

  TCarta mano[NGIOCATORI][5];

  srand(time(NULL));

  int i,j;
  for (i=0; i<NMANI; ++i) {
    mescola(mazzo);
    dai_le_carte(mazzo, mano);
    for (j=0; j<NGIOCATORI; j++) {
      conta_mani++;
      if (colore(mano[j])) {
	conta_colore++;
	printf("Mano numero: %d, Colori: %d, Prob.: %f\n", conta_mani, conta_colore, (double) conta_colore / conta_mani);
      }
    }
  }
}

int main() {
  TSeme seme;
  int valore;
  TCarta mazzo[52];

  int i;
  for (i=0; i<52; i++) {
    
    valore = i%13 + 1;
    
    if (i<13) seme = fiori;
    else if (i<26) seme = quadri;
    else if (i<39) seme = cuori;
    else seme = picche;

    assegna(&mazzo[i],valore, seme); 
  }

  for (i=26; i<39; i++)
    stampa_carta(&mazzo[i]);

  gioca_poker(mazzo);

  return 0;
}
